/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.30 from the
 * contents of FileHandle.xs. Do not edit this file, edit FileHandle.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FileHandle.xs"
/* vim: ts=8 sw=4 expandtab:
 * ************************************************************************
 * This file is part of the Devel::NYTProf package.
 * See http://metacpan.org/release/Devel-NYTProf/
 * For Copyright see lib/Devel/NYTProf.pm
 * For contribution history see repository logs.
 * ************************************************************************
 */

#define PERL_NO_GET_CONTEXT                       /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#if defined(PERL_IMPLICIT_SYS) && !defined(NO_XSLOCKS)
#  ifndef fgets
#    define fgets PerlSIO_fgets
#  endif
#endif

#include "FileHandle.h"
#include "NYTProf.h"

#define NEED_newRV_noinc
#define NEED_sv_2pvbyte
#define NEED_my_snprintf
#include "ppport.h"

#ifdef HAS_ZLIB
#  include <zlib.h>
#endif

#define NYTP_FILE_STDIO         0
#define NYTP_FILE_DEFLATE       1
#define NYTP_FILE_INFLATE       2

/* to help find places in NYTProf.xs where we don't save/restore errno */
#if 0
#define ERRNO_PROBE errno=__LINE__
#else
#define ERRNO_PROBE (void)0
#endif

/* During profiling the large buffer collects the raw data until full.
 * Then flush_output zips it into the small buffer and writes it to disk.
 * A scale factor of ~90 makes the large buffer usually almost fill the small
 * one when zipped (so calls to flush_output() almost always trigger one fwrite()).
 * We use a lower number to save some memory as there's little performance
 * impact either way.
 */
#define NYTP_FILE_SMALL_BUFFER_SIZE   4096
#define NYTP_FILE_LARGE_BUFFER_SIZE   (NYTP_FILE_SMALL_BUFFER_SIZE * 40)

#ifdef HAS_ZLIB
#  define FILE_STATE(f)         ((f)->state)
#else
#  define FILE_STATE(f)         NYTP_FILE_STDIO
#endif

#if defined(PERL_IMPLICIT_CONTEXT) && ! defined(tTHX)
#  define tTHX PerlInterpreter*
#endif

struct NYTP_file_t {
    FILE *file;
#ifdef PERL_IMPLICIT_CONTEXT
    tTHX aTHX; /* on 5.8 and older, pTHX contains a "register" which is not
                  compatible with a struct def, so use something else */
#endif
#ifdef HAS_ZLIB
    unsigned char state;
    bool stdio_at_eof;
    bool zlib_at_eof;
    /* For input only, the position we are in large_buffer.  */
    unsigned int count;
    z_stream zs;
    unsigned char small_buffer[NYTP_FILE_SMALL_BUFFER_SIZE];
    unsigned char large_buffer[NYTP_FILE_LARGE_BUFFER_SIZE];
#endif
};

/* unlike dTHX which contains a function call, and therefore can never be
  optimized away, even if return value isn't used, the below will optimize away
  if NO_XSLOCKS is defined and PerlIO is not being used (i.e. native C lib
  IO is being used on Win32 )*/
#ifdef PERL_IMPLICIT_CONTEXT
#  define dNFTHX(x) dTHXa((x)->aTHX)
#else
#  define dNFTHX(x) dNOOP
#endif

/* XXX The proper return value would be Off_t */
long
NYTP_tell(NYTP_file file) {
    ERRNO_PROBE;

#ifdef HAS_ZLIB
    /* This has to work with compressed files as it's used in the croaking
       routine.  */
    if (FILE_STATE(file) != NYTP_FILE_STDIO) {
        return FILE_STATE(file) == NYTP_FILE_INFLATE
            ? file->zs.total_out : file->zs.total_in;
    }
#endif
    {
        dNFTHX(file);
        return (long)ftell(file->file);
    }
}

#ifdef HAS_ZLIB
const char *
NYTP_type_of_offset(NYTP_file file) {
    switch (FILE_STATE(file)) {
    case NYTP_FILE_STDIO:
        return "";
    case NYTP_FILE_DEFLATE:
        return " in compressed output data";
        break;
    case NYTP_FILE_INFLATE:
        return " in compressed input data";
        break;
    default:
        return Perl_form_nocontext(" in stream in unknown state %d",
                                   FILE_STATE(file));
    }
}
#endif

#ifdef HAS_ZLIB
#  define CROAK_IF_NOT_STDIO(file, where)           \
    STMT_START {                                    \
        if (FILE_STATE(file) != NYTP_FILE_STDIO) {  \
            compressed_io_croak((file), (where));   \
        }                                           \
    } STMT_END
#else
#  define CROAK_IF_NOT_STDIO(file, where)
#endif

#ifdef HAS_ZLIB
#ifdef HASATTRIBUTE_NORETURN
__attribute__noreturn__
#endif 
static void
compressed_io_croak(NYTP_file file, const char *function) {
    const char *what;

    switch (FILE_STATE(file)) {
    case NYTP_FILE_STDIO:
        what = "stdio";
        break;
    case NYTP_FILE_DEFLATE:
        what = "compressed output";
        break;
    case NYTP_FILE_INFLATE:
        what = "compressed input";
        break;
    default:
        croak("Can't use function %s() on a stream of type %d at offset %ld",
              function, FILE_STATE(file), NYTP_tell(file));
    }
    croak("Can't use function %s() on a %s stream at offset %ld", function,
          what, NYTP_tell(file));
}

void
NYTP_start_deflate(NYTP_file file, int compression_level) {
    int status;
    ERRNO_PROBE;

    CROAK_IF_NOT_STDIO(file, "NYTP_start_deflate");
    FILE_STATE(file) = NYTP_FILE_DEFLATE;
    file->zs.next_in = (Bytef *) file->large_buffer;
    file->zs.avail_in = 0;
    file->zs.next_out = (Bytef *) file->small_buffer;
    file->zs.avail_out = NYTP_FILE_SMALL_BUFFER_SIZE;
    file->zs.zalloc = (alloc_func) 0;
    file->zs.zfree = (free_func) 0;
    file->zs.opaque = 0;

    status = deflateInit2(&(file->zs), compression_level, Z_DEFLATED,
        15 /* windowBits */,
        9 /* memLevel */, Z_DEFAULT_STRATEGY);
    if (status != Z_OK) {
        croak("deflateInit2 failed, error %d (%s)", status, file->zs.msg);
    }
}

void
NYTP_start_inflate(NYTP_file file) {
    int status;
    ERRNO_PROBE;

    CROAK_IF_NOT_STDIO(file, "NYTP_start_inflate");
    FILE_STATE(file) = NYTP_FILE_INFLATE;

    file->zs.next_in = (Bytef *) file->small_buffer;
    file->zs.avail_in = 0;
    file->zs.next_out = (Bytef *) file->large_buffer;
    file->zs.avail_out = NYTP_FILE_LARGE_BUFFER_SIZE;
    file->zs.zalloc = (alloc_func) 0;
    file->zs.zfree = (free_func) 0;
    file->zs.opaque = 0;

    status = inflateInit2(&(file->zs), 15);
    if (status != Z_OK) {
        croak("inflateInit2 failed, error %d (%s)", status, file->zs.msg);
    }
}
#endif

NYTP_file
NYTP_open(const char *name, const char *mode) {
    dTHX;
    FILE *raw_file = fopen(name, mode);
    NYTP_file file;
    ERRNO_PROBE;

    if (!raw_file)
        return NULL;

/* MS libc has 4096 as default, this is too slow for GB size profiling data */
    if (setvbuf(raw_file, NULL, _IOFBF, 16384))
        return NULL;
    Newx(file, 1, struct NYTP_file_t);
    file->file = raw_file;

#ifdef PERL_IMPLICIT_CONTEXT
    file->aTHX = aTHX;
#endif
#ifdef HAS_ZLIB
    file->state = NYTP_FILE_STDIO;
    file->count = 0;
    file->stdio_at_eof = FALSE;
    file->zlib_at_eof = FALSE;

    file->zs.msg = (char *)"[Oops. zlib hasn't updated this error string]";
#endif

    return file;
}

#ifdef HAS_ZLIB

static void
grab_input(NYTP_file ifile) {
    dNFTHX(ifile);
    ERRNO_PROBE;

    ifile->count = 0;
    ifile->zs.next_out = (Bytef *) ifile->large_buffer;
    ifile->zs.avail_out = NYTP_FILE_LARGE_BUFFER_SIZE;

#ifdef DEBUG_INFLATE
    fprintf(stderr, "grab_input enter\n");
#endif

    while (1) {
        int status;

        if (ifile->zs.avail_in == 0 && !ifile->stdio_at_eof) {
            size_t got = fread(ifile->small_buffer, 1,
                               NYTP_FILE_SMALL_BUFFER_SIZE, ifile->file);

            if (got == 0) {
                if (!feof(ifile->file)) {
                    int eno = errno;
                    croak("grab_input failed: %d (%s)", eno, strerror(eno));
                }
                ifile->stdio_at_eof = TRUE;
            }

            ifile->zs.avail_in = got;
            ifile->zs.next_in = (Bytef *) ifile->small_buffer;
        }

#ifdef DEBUG_INFLATE
        fprintf(stderr, "grab_input predef  next_in= %p avail_in= %08x\n"
                        "                   next_out=%p avail_out=%08x"
                " eof=%d,%d\n", ifile->zs.next_in, ifile->zs.avail_in,
                ifile->zs.next_out, ifile->zs.avail_out, ifile->stdio_at_eof,
                ifile->zlib_at_eof);
#endif

        status = inflate(&(ifile->zs), Z_NO_FLUSH);

#ifdef DEBUG_INFLATE
        fprintf(stderr, "grab_input postdef next_in= %p avail_in= %08x\n"
                        "                   next_out=%p avail_out=%08x "
                "status=%d\n", ifile->zs.next_in, ifile->zs.avail_in,
                ifile->zs.next_out, ifile->zs.avail_out, status);
#endif

        if (!(status == Z_OK || status == Z_STREAM_END)) {
            if (ifile->stdio_at_eof)
                croak("Profile data incomplete, inflate error %d (%s) at end of input file,"
                    " perhaps the process didn't exit cleanly or the file has been truncated "
                    " (refer to TROUBLESHOOTING in the documentation)\n",
                    status, ifile->zs.msg);
            croak("Error reading file: inflate failed, error %d (%s) at offset %ld in input file",
                  status, ifile->zs.msg, (long)ftell(ifile->file));
        }

        if (ifile->zs.avail_out == 0 || status == Z_STREAM_END) {
            if (status == Z_STREAM_END) {
                ifile->zlib_at_eof = TRUE;
            }
            return;
        }
    }
}

#endif


size_t
NYTP_read_unchecked(NYTP_file ifile, void *buffer, size_t len) {
    dNFTHX(ifile);
#ifdef HAS_ZLIB
    size_t result = 0;
#endif
    ERRNO_PROBE;
    if (FILE_STATE(ifile) == NYTP_FILE_STDIO) {
        return fread(buffer, 1, len, ifile->file);
    }
#ifdef HAS_ZLIB
    else if (FILE_STATE(ifile) != NYTP_FILE_INFLATE) {
        compressed_io_croak(ifile, "NYTP_read");
        return 0;
    }
    while (1) {
        unsigned char *p = ifile->large_buffer + ifile->count;
        int remaining = ((unsigned char *) ifile->zs.next_out) - p;

        if (remaining >= len) {
            Copy(p, buffer, len, unsigned char);
            ifile->count += len;
            result += len;
            return result;
        }
        Copy(p, buffer, remaining, unsigned char);
        ifile->count = NYTP_FILE_LARGE_BUFFER_SIZE;
        result += remaining;
        len -= remaining;
        buffer = (void *)(remaining + (char *)buffer);
        if (ifile->zlib_at_eof)
            return result;
        grab_input(ifile);
    }
#endif
}


size_t
NYTP_read(NYTP_file ifile, void *buffer, size_t len, const char *what) {
    size_t got = NYTP_read_unchecked(ifile, buffer, len);
    if (got != len) {
        croak("Profile format error whilst reading %s at %ld%s: expected %ld got %ld, %s (see TROUBLESHOOTING in docs)",
              what, NYTP_tell(ifile), NYTP_type_of_offset(ifile), (long)len, (long)got,
                (NYTP_eof(ifile)) ? "end of file" : NYTP_fstrerror(ifile));
    }
    return len;
}

/* This isn't exactly fgets. It will resize the buffer as needed, and returns
   a pointer to one beyond the read data (usually the terminating '\0'), or
   NULL if it hit error/EOF */

char *
NYTP_gets(NYTP_file ifile, char **buffer_p, size_t *len_p) {
    char *buffer = *buffer_p;
    size_t len = *len_p;
    size_t prev_len = 0;
    ERRNO_PROBE;

#ifdef HAS_ZLIB
    if (FILE_STATE(ifile) == NYTP_FILE_INFLATE) {
        while (1) {
            const unsigned char *const p = ifile->large_buffer + ifile->count;
            const unsigned int remaining = ((unsigned char *) ifile->zs.next_out) - p;
            unsigned char *const nl = (unsigned char *)memchr(p, '\n', remaining);
            size_t got;
            size_t want;
            size_t extra;

            if (nl) {
                want = nl + 1 - p;
                extra = want + 1; /* 1 more to add a \0 */
            } else {
                want = extra = remaining;
            }

            if (extra > len - prev_len) {
                prev_len = len;
                len += extra;
                buffer = (char *)saferealloc(buffer, len);
            }

            got = NYTP_read_unchecked(ifile, buffer + prev_len, want);
            if (got != want)
                croak("NYTP_gets unexpected short read. got %lu, expected %lu\n",
                      (unsigned long)got, (unsigned long)want);

            if (nl) {
                buffer[prev_len + want] = '\0';
                *buffer_p = buffer;
                *len_p = len;
                return buffer + prev_len + want;
            }
            if (ifile->zlib_at_eof) {
                *buffer_p = buffer;
                *len_p = len;
                return NULL;
            }
            grab_input(ifile);
        }
    }
#endif
    CROAK_IF_NOT_STDIO(ifile, "NYTP_gets");

    {
        dNFTHX(ifile);
        while(fgets(buffer + prev_len, (int)(len - prev_len), ifile->file)) {
            /* We know that there are no '\0' bytes in the part we've already
               read, so don't bother running strlen() over that part.  */
            char *end = buffer + prev_len + strlen(buffer + prev_len);
            if (end[-1] == '\n') {
                *buffer_p = buffer;
                *len_p = len;
                return end;
            }
            prev_len = len - 1; /* -1 to take off the '\0' at the end */
            len *= 2;
            buffer = (char *)saferealloc(buffer, len);
        }
    }
    *buffer_p = buffer;
    *len_p = len;
    return NULL;
}


#ifdef HAS_ZLIB
/* Cheat, by telling zlib about a reduced amount of available output space,
   such that our next write of the (slightly underused) output buffer will
   align the underlying file pointer back with the size of our output buffer
   (and hopefully the underlying OS block writes).  */
static void
sync_avail_out_to_ftell(NYTP_file ofile) {
    dNFTHX(ofile);
    const long result = ftell(ofile->file);
    const unsigned long where = result < 0 ? 0 : result;
    ERRNO_PROBE;
    ofile->zs.avail_out =
        NYTP_FILE_SMALL_BUFFER_SIZE - where % NYTP_FILE_SMALL_BUFFER_SIZE;
#ifdef DEBUG_DEFLATE
    fprintf(stderr, "sync_avail_out_to_ftell pos=%ld, avail_out=%lu\n",
            result, (unsigned long) ofile->zs.avail_out);
#endif
}

/* flush has values as described for "allowed flush values" in zlib.h  */
static void
flush_output(NYTP_file ofile, int flush) {
    dNFTHX(ofile);
    ERRNO_PROBE;

    ofile->zs.next_in = (Bytef *) ofile->large_buffer;

#ifdef DEBUG_DEFLATE
    fprintf(stderr, "flush_output enter   flush = %d\n", flush);
#endif
    while (1) {
        int status;
#ifdef DEBUG_DEFLATE
        fprintf(stderr, "flush_output predef  next_in= %p avail_in= %08x\n"
                        "                     next_out=%p avail_out=%08x"
                " flush=%d\n", ofile->zs.next_in, ofile->zs.avail_in,
                ofile->zs.next_out, ofile->zs.avail_out, flush);
#endif
        status = deflate(&(ofile->zs), flush);

        /* workaround for RT#50851 */
        if (status == Z_BUF_ERROR && flush != Z_NO_FLUSH
                && !ofile->zs.avail_in && ofile->zs.avail_out)
            status = Z_OK;

#ifdef DEBUG_DEFLATE
        fprintf(stderr, "flush_output postdef next_in= %p avail_in= %08x\n"
                        "                     next_out=%p avail_out=%08x "
                "status=%d\n", ofile->zs.next_in, ofile->zs.avail_in,
                ofile->zs.next_out, ofile->zs.avail_out, status);
#endif
      
        if (status == Z_OK || status == Z_STREAM_END) {
            if (ofile->zs.avail_out == 0 || flush != Z_NO_FLUSH) {
                int terminate
                    = ofile->zs.avail_in == 0 && ofile->zs.avail_out > 0;
                size_t avail = ((unsigned char *) ofile->zs.next_out)
                    - ofile->small_buffer;
                const unsigned char *where = ofile->small_buffer;

                while (avail > 0) {
                    size_t count = fwrite(where, 1, avail, ofile->file);

                    if (count > 0) {
                        where += count;
                        avail -= count;
                    } else {
                        int eno = errno;
                        croak("fwrite in flush error %d: %s", eno,
                              strerror(eno));
                    }
                }
                ofile->zs.next_out = (Bytef *) ofile->small_buffer;
                ofile->zs.avail_out = NYTP_FILE_SMALL_BUFFER_SIZE;
                if (terminate) {
                    ofile->zs.avail_in = 0;
                    if (flush == Z_SYNC_FLUSH) {
                        sync_avail_out_to_ftell(ofile);
                    }
                    return;
                }
            } else {
                ofile->zs.avail_in = 0;
                return;
            }
        } else {
            croak("deflate(%ld,%d) failed, error %d (%s) in pid %d",
                (long)ofile->zs.avail_in, flush, status, ofile->zs.msg, getpid());
        }
    }
}
#endif

size_t
NYTP_write(NYTP_file ofile, const void *buffer, size_t len) {
#ifdef HAS_ZLIB
    size_t result = 0;
#endif
    ERRNO_PROBE;

    if (FILE_STATE(ofile) == NYTP_FILE_STDIO) {
        /* fwrite with len==0 is problematic */
        /* http://www.opengroup.org/platform/resolutions/bwg98-007.html */
        if (len == 0)
            return len;
        {
            dNFTHX(ofile);
            if (fwrite(buffer, 1, len, ofile->file) < 1) {
                int eno = errno;
                croak("fwrite error %d writing %ld bytes to fd%d: %s",
                    eno, (long)len, fileno(ofile->file), strerror(eno));
            }
        }
        return len;
    }
#ifdef HAS_ZLIB
    else if (FILE_STATE(ofile) != NYTP_FILE_DEFLATE) {
        compressed_io_croak(ofile, "NYTP_write");
        return 0;
    }
    while (1) {
        int remaining = NYTP_FILE_LARGE_BUFFER_SIZE - ofile->zs.avail_in;
        unsigned char *p = ofile->large_buffer + ofile->zs.avail_in;

        if (remaining >= len) {
            Copy(buffer, p, len, unsigned char);
            ofile->zs.avail_in += len;
            result += len;
            return result;
        } else {
            /* Copy what we can, then flush the buffer. Lather, rinse, repeat.
             */
            Copy(buffer, p, remaining, unsigned char);
            ofile->zs.avail_in = NYTP_FILE_LARGE_BUFFER_SIZE;
            result += remaining;
            len -= remaining;
            buffer = (void *)(remaining + (char *)buffer);
            flush_output(ofile, Z_NO_FLUSH);
        }
    }
#endif
}

int
NYTP_printf(NYTP_file ofile, const char *format, ...) {
    int retval;
    va_list args;
    ERRNO_PROBE;

    CROAK_IF_NOT_STDIO(ofile, "NYTP_printf");

    va_start(args, format);
    {
        dNFTHX(ofile);
        retval = vfprintf(ofile->file, format, args);
    }
    va_end(args);

    return retval;
}

int
NYTP_flush(NYTP_file file) {
    ERRNO_PROBE;
#ifdef HAS_ZLIB
    if (FILE_STATE(file) == NYTP_FILE_DEFLATE) {
        flush_output(file, Z_SYNC_FLUSH);
    }
#endif
    {
        dNFTHX(file);
        return fflush(file->file);
    }
}

int
NYTP_eof(NYTP_file ifile) {
    ERRNO_PROBE;
#ifdef HAS_ZLIB
    if (FILE_STATE(ifile) == NYTP_FILE_INFLATE) {
        return ifile->zlib_at_eof;
    }
#endif
    {
        dNFTHX(ifile);
        return feof(ifile->file);
    }
}

const char *
NYTP_fstrerror(NYTP_file file) {
#ifdef HAS_ZLIB
    if (FILE_STATE(file) == NYTP_FILE_DEFLATE || FILE_STATE(file) == NYTP_FILE_INFLATE) {
        return file->zs.msg;
    }
#endif
    {
        dNFTHX(file);
        return strerror(errno);
    }
}

int
NYTP_close(NYTP_file file, int discard) {
    FILE *raw_file = file->file;
    int result;
    dNFTHX(file);
    ERRNO_PROBE;

#ifdef HAS_ZLIB
    if (!discard && FILE_STATE(file) == NYTP_FILE_DEFLATE) {
        const double ratio = file->zs.total_in / (double) file->zs.total_out;
        flush_output(file, Z_FINISH);
        fprintf(raw_file, "#\n"
                "# Compressed %lu bytes to %lu, ratio %f:1, data shrunk by %f%%\n",
                (long)file->zs.total_in, (long)file->zs.total_out, ratio,
                100 * (1 - 1 / ratio));
    }

    if (FILE_STATE(file) == NYTP_FILE_DEFLATE) {
        int status = deflateEnd(&(file->zs));
        if (status != Z_OK) {
            if (discard && status == Z_DATA_ERROR) {
                /* deflateEnd returns Z_OK if success, Z_STREAM_ERROR if the
                   stream state was inconsistent, Z_DATA_ERROR if the stream
                   was freed prematurely (some input or output was discarded).
                */
            } else {
                croak("deflateEnd failed, error %d (%s) in %d", status,
                      file->zs.msg, getpid());
            }
        }
    }
    else if (FILE_STATE(file) == NYTP_FILE_INFLATE) {
        int err = inflateEnd(&(file->zs));
        if (err != Z_OK) {
            croak("inflateEnd failed, error %d (%s)", err, file->zs.msg);
        }
    }
#endif

    Safefree(file);

    result = ferror(raw_file) ? errno : 0;

    if (discard) {
        /* close the underlying fd first so any buffered data gets discarded
         * when fclose is called below */
        close(fileno(raw_file));
    }

    if (result || discard) {
        /* Something has already gone wrong, so try to preserve its error */
        fclose(raw_file);
        return result;
    }
    return fclose(raw_file) == 0 ? 0 : errno;
}


/* ====== Low-level element I/O functions ====== */

/**
 * Output an integer in bytes, optionally preceded by a tag. Use the special tag
 * NYTP_TAG_NO_TAG to suppress the tag output. A wrapper macro output_u32(fh, i)
 * does this for you.
 * "In bytes" means output the number in binary, using the least number of bytes
 * possible.  All numbers are positive. Use sign slot as a marker
 */
static size_t
output_tag_u32(NYTP_file file, unsigned char tag, U32 i)
{
    U8 buffer[6];
    U8 *p = buffer;

    if (tag != NYTP_TAG_NO_TAG)
        *p++ = tag;

    /* general case. handles all integers */
    if (i < 0x80) {                               /* < 8 bits */
        *p++ = (U8)i;
    }
    else if (i < 0x4000) {                        /* < 16 bits */
        *p++ = (U8)((i >> 8) | 0x80);
        *p++ = (U8)i;
    }
    else if (i < 0x200000) {                      /* < 24 bits */
        *p++ = (U8)((i >> 16) | 0xC0);
        *p++ = (U8)(i >> 8);
        *p++ = (U8)i;
    }
    else if (i < 0x10000000) {                    /* < 32 bits */
        *p++ = (U8)((i >> 24) | 0xE0);
        *p++ = (U8)(i >> 16);
        *p++ = (U8)(i >> 8);
        *p++ = (U8)i;
    }
    else {                                        /* need all the bytes. */
        *p++ = 0xFF;
        *p++ = (U8)(i >> 24);
        *p++ = (U8)(i >> 16);
        *p++ = (U8)(i >> 8);
        *p++ = (U8)i;
    }
    return NYTP_write(file, buffer, p - buffer);
}

static size_t
output_tag_i32(NYTP_file file, unsigned char tag, I32 i)
{
    return output_tag_u32(file, tag, *( (U32*) &i ) );
}

#define     output_u32(fh, i)   output_tag_u32((fh), NYTP_TAG_NO_TAG, (i))
#define     output_i32(fh, i)   output_tag_i32((fh), NYTP_TAG_NO_TAG, (i))


/**
 * Read an integer by decompressing the next 1 to 4 bytes of binary into a 32-
 * bit integer. See output_int() for the compression details.
 */
U32
read_u32(NYTP_file ifile)
{
    unsigned char d;
    U32 newint;

    NYTP_read(ifile, &d, sizeof(d), "integer prefix");

    if (d < 0x80) {                               /* < 8 bits */
        newint = d;
    }
    else {
        unsigned char buffer[4];
        unsigned char *p = buffer;
        unsigned int length;

        if (d < 0xC0) {                          /* < 16 bits */
            newint = d & 0x7F;
            length = 1;
        }
        else if (d < 0xE0) {                     /* < 24 bits */
            newint = d & 0x1F;
            length = 2;
        }
        else if (d < 0xFF) {                     /* < 32 bits */
            newint = d & 0xF;
            length = 3;
        }
        else { /* d == 0xFF */                   /* = 32 bits */
            newint = 0;
            length = 4;
        }
        NYTP_read(ifile, buffer, length, "integer");
        while (length--) {
            newint <<= 8;
            newint |= *p++;
        }
    }
    return newint;
}

I32
read_i32(NYTP_file ifile) {
    U32 u = read_u32(ifile);
    return *( (I32*)&u );
}


static size_t
output_str(NYTP_file file, const char *str, I32 len) {    /* negative len signifies utf8 */
    unsigned char tag = NYTP_TAG_STRING;
    size_t retval;
    size_t total;

    if (len < 0) {
        tag = NYTP_TAG_STRING_UTF8;
        len = -len;
    }

    total = retval = output_tag_u32(file, tag, len);
    if (retval <= 0)
        return retval;

    if (len) {
        total += retval = NYTP_write(file, str, len);
        if (retval <= 0)
            return retval;
    }

    return total;
}


/**
 * Output a double precision float via a simple binary write of the memory.
 * (Minor portbility issues are seen as less important than speed and space.)
 */
size_t
output_nv(NYTP_file file, NV nv)
{
    return NYTP_write(file, (unsigned char *)&nv, sizeof(NV));
}

/**
 * Read an NV by simple byte copy to memory
 */
NV
read_nv(NYTP_file ifile)
{
    NV nv;
    /* no error checking on the assumption that a later token read will
     * detect the error/eof condition
     */
    NYTP_read(ifile, (unsigned char *)&nv, sizeof(NV), "float");
    return nv;
}


/* ====== Higher-level protocol I/O functions ====== */

size_t
NYTP_write_header(NYTP_file ofile, U32 major, U32 minor)
{
    return NYTP_printf(ofile, "NYTProf %u %u\n", major, minor);
}

size_t
NYTP_write_comment(NYTP_file ofile, const char *format, ...) {
    size_t retval;
    size_t retval2;
    va_list args;
    ERRNO_PROBE;

    retval = NYTP_write(ofile, "#", 1);
    if (retval != 1)
        return retval;

    va_start(args, format);

    if(strEQ(format, "%s")) {
        const char * const s = va_arg(args, char*);
        STRLEN len = strlen(s);
        retval = NYTP_write(ofile, s, len);
    } else {
        CROAK_IF_NOT_STDIO(ofile, "NYTP_printf");
        {
            dNFTHX(ofile);
            retval = vfprintf(ofile->file, format, args);
        }
    }
    va_end(args);

    retval2 = NYTP_write(ofile, "\n", 1);
    if (retval2 != 1)
        return retval2;

    return retval + 2;
}

static size_t
NYTP_write_plain_kv(NYTP_file ofile, const char prefix,
                            const char *key, size_t key_len,
                            const char *value, size_t value_len)
{
    size_t total;
    size_t retval;

    total = retval = NYTP_write(ofile, &prefix, 1);
    if (retval != 1)
        return retval;

    total += retval = NYTP_write(ofile, key, key_len);
    if (retval != key_len)
        return retval;

    total += retval = NYTP_write(ofile, "=", 1);
    if (retval != 1)
        return retval;

    total += retval = NYTP_write(ofile, value, value_len);
    if (retval != value_len)
        return retval;

    total += retval = NYTP_write(ofile, "\n", 1);
    if (retval != 1)
        return retval;

    return total;
}

size_t
NYTP_write_attribute_string(NYTP_file ofile,
                            const char *key, size_t key_len,
                            const char *value, size_t value_len)
{
    return NYTP_write_plain_kv(ofile, ':', key, key_len, value, value_len);
}

#ifndef CHAR_BIT
#  define CHAR_BIT          8
#endif
#define LOG_2_OVER_LOG_10   0.30103

size_t
NYTP_write_attribute_unsigned(NYTP_file ofile, const char *key,
                              size_t key_len, unsigned long value)
{
    /* 3: 1 for rounding errors, 1 for the '\0'  */
    char buffer[(int)(sizeof (unsigned long) * CHAR_BIT * LOG_2_OVER_LOG_10 + 3)];
    const size_t len = my_snprintf(buffer, sizeof(buffer), "%lu", value);

    return NYTP_write_attribute_string(ofile, key, key_len, buffer, len);
}

size_t
NYTP_write_attribute_signed(NYTP_file ofile, const char *key,
                            size_t key_len, long value)
{
    /* 3: 1 for rounding errors, 1 for the sign, 1 for the '\0'  */
    char buffer[(int)(sizeof (long) * CHAR_BIT * LOG_2_OVER_LOG_10 + 3)];
    const size_t len = my_snprintf(buffer, sizeof(buffer), "%ld", value);

    return NYTP_write_attribute_string(ofile, key, key_len, buffer, len);
}

size_t
NYTP_write_attribute_nv(NYTP_file ofile, const char *key,
                            size_t key_len, NV value)
{
    char buffer[NV_DIG+20]; /* see Perl_sv_2pv_flags */
    const size_t len = my_snprintf(buffer, sizeof(buffer), "%"NVgf, value);

    return NYTP_write_attribute_string(ofile, key, key_len, buffer, len);
}

/* options */

size_t
NYTP_write_option_pv(NYTP_file ofile,
                    const char *key,
                    const char *value, size_t value_len)
{
    return NYTP_write_plain_kv(ofile, '!', key, strlen(key), value, value_len);
}

size_t
NYTP_write_option_iv(NYTP_file ofile, const char *key, IV value)
{
    /* 3: 1 for rounding errors, 1 for the sign, 1 for the '\0'  */
    char buffer[(int)(sizeof (IV) * CHAR_BIT * LOG_2_OVER_LOG_10 + 3)];
    const size_t len = my_snprintf(buffer, sizeof(buffer), "%"IVdf, value);

    return NYTP_write_option_pv(ofile, key, buffer, len);
}

/* other */

#ifdef HAS_ZLIB

size_t
NYTP_start_deflate_write_tag_comment(NYTP_file ofile, int compression_level) {
    const unsigned char tag = NYTP_TAG_START_DEFLATE;
    size_t total;
    size_t retval;

    total = retval = NYTP_write_comment(ofile, "Compressed at level %d with zlib %s",
                                        compression_level, zlibVersion());

    if (retval < 1)
        return retval;

    total += retval = NYTP_write(ofile, &tag, sizeof(tag));
    if (retval < 1)
        return retval;

    NYTP_start_deflate(ofile, compression_level);

    return total;
}

#endif

size_t
NYTP_write_process_start(NYTP_file ofile, U32 pid, U32 ppid,
                         NV time_of_day)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_PID_START, pid);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, ppid);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, time_of_day);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_process_end(NYTP_file ofile, U32 pid, NV time_of_day)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_PID_END, pid);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, time_of_day);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_sawampersand(NYTP_file ofile, U32 fid, U32 line)
{
    size_t total;
    size_t retval;

    total = retval = NYTP_write_attribute_unsigned(ofile, STR_WITH_LEN("sawampersand_fid"),  fid);
    if (retval < 1)
        return retval;

    total += retval = NYTP_write_attribute_unsigned(ofile, STR_WITH_LEN("sawampersand_line"), line);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_new_fid(NYTP_file ofile, U32 id, U32 eval_fid,
                   U32 eval_line_num, U32 flags,
                   U32 size, U32 mtime,
                   const char *name, I32 len)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_NEW_FID, id);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, eval_fid);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, eval_line_num);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, flags);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, size);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, mtime);
    if (retval < 1)
        return retval;

    total += retval = output_str(ofile, name, len);
    if (retval < 1)
        return retval;

    return total;
}

static size_t
write_time_common(NYTP_file ofile, unsigned char tag, I32 elapsed, U32 overflow,
                  U32 fid, U32 line)
{
    size_t total;
    size_t retval;

    if (overflow) {
        dNFTHX(ofile);
        /* XXX needs protocol change to output a new time-overflow tag */
        fprintf(stderr, "profile time overflow of %lu seconds discarded!\n",
            (unsigned long)overflow);
    }

    total = retval = output_tag_i32(ofile, tag, elapsed);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, fid);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, line);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_time_block(NYTP_file ofile, I32 elapsed, U32 overflow,
    U32 fid, U32 line, U32 last_block_line, U32 last_sub_line)
{
    size_t total;
    size_t retval;

    total = retval = write_time_common(ofile, NYTP_TAG_TIME_BLOCK, elapsed, overflow,
                                       fid, line);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, last_block_line);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, last_sub_line);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_time_line(NYTP_file ofile, I32 elapsed, U32 overflow,
    U32 fid, U32 line)
{
    return write_time_common(ofile, NYTP_TAG_TIME_LINE, elapsed, overflow, fid, line);
}


size_t
NYTP_write_call_entry(NYTP_file ofile, U32 caller_fid, U32 caller_line)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_SUB_ENTRY, caller_fid);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, caller_line);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_call_return(NYTP_file ofile, U32 prof_depth, const char *called_subname_pv,
    NV incl_subr_ticks, NV excl_subr_ticks)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_SUB_RETURN, prof_depth);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, incl_subr_ticks);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, excl_subr_ticks);
    if (retval < 1)
        return retval;

    if (!called_subname_pv)
        called_subname_pv = "(null)";
    total += retval = output_str(ofile, called_subname_pv, strlen(called_subname_pv));
    if (retval < 1)
        return retval;

    return total;
}


size_t
NYTP_write_sub_info(NYTP_file ofile, U32 fid,
                    const char *name, I32 len,
                    U32 first_line, U32 last_line)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_SUB_INFO, fid);
    if (retval < 1)
        return retval;

    total += retval = output_str(ofile, name, (I32)len);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, first_line);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, last_line);
    if (retval < 1)
        return retval;

    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_sub_callers(NYTP_file ofile, U32 fid, U32 line,
                       const char *caller_name, I32 caller_name_len,
                       U32 count, NV incl_rtime, NV excl_rtime,
                       NV reci_rtime, U32 depth,
                       const char *called_name, I32 called_name_len)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_SUB_CALLERS, fid);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, line);
    if (retval < 1)
        return retval;

    total += retval = output_str(ofile, caller_name, caller_name_len);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, count);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, incl_rtime);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, excl_rtime);
    if (retval < 1)
        return retval;

    total += retval = output_nv(ofile, reci_rtime);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, depth);
    if (retval < 1)
        return retval;

    total += retval = output_str(ofile, called_name, called_name_len);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_src_line(NYTP_file ofile, U32 fid,
                    U32 line, const char *text, I32 text_len)
{
    size_t total;
    size_t retval;

    total = retval = output_tag_u32(ofile, NYTP_TAG_SRC_LINE, fid);
    if (retval < 1)
        return retval;

    total += retval = output_u32(ofile, line);
    if (retval < 1)
        return retval;

    total += retval = output_str(ofile, text, text_len);
    if (retval < 1)
        return retval;

    return total;
}

size_t
NYTP_write_discount(NYTP_file ofile)
{
    const unsigned char tag = NYTP_TAG_DISCOUNT;
    return NYTP_write(ofile, &tag, sizeof(tag));
}


#line 1347 "FileHandle.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1491 "FileHandle.c"

XS_EUPXS(XS_Devel__NYTProf__FileHandle_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pathname, mode");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	pathname = (char *)SvPV_nolen(ST(0))
;
	char *	mode = (char *)SvPV_nolen(ST(1))
;
#line 1346 "FileHandle.xs"
        NYTP_file fh = NYTP_open(pathname, mode);
        SV *object;
#line 1509 "FileHandle.c"
#line 1349 "FileHandle.xs"
        if(!fh)
            XSRETURN(0);
        object = newSV(0);
        sv_usepvn(object, (char *) fh, sizeof(struct NYTP_file_t));
        ST(0) = sv_bless(sv_2mortal(newRV_noinc(object)), gv_stashpvs("Devel::NYTProf::FileHandle", GV_ADD));
        XSRETURN(1);
#line 1517 "FileHandle.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_DESTROY)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	NYTP_file	handle;
#line 1362 "FileHandle.xs"
        SV *guts;
#line 1535 "FileHandle.c"
	int	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			GvNAME(CvGV(cv)),
			"handle")
;
#line 1364 "FileHandle.xs"
	guts = SvRV(ST(0));
        PERL_UNUSED_VAR(ix);
        RETVAL = NYTP_close(handle, 0);
        SvPV_set(guts, NULL);
        SvLEN_set(guts, 0);
#line 1552 "FileHandle.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "handle, string");
    {
	NYTP_file	handle;
	SV *	string = ST(1)
;
#line 1377 "FileHandle.xs"
        STRLEN len;
        char *p;
#line 1572 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write",
			"handle")
;
#line 1380 "FileHandle.xs"
        p = SvPVbyte(string, len);
        RETVAL = NYTP_write(handle, p, len);
#line 1586 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef HAS_ZLIB
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Devel__NYTProf__FileHandle_start_deflate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_start_deflate)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "handle, compression_level = 6");
    {
	NYTP_file	handle;
	int	compression_level;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::start_deflate",
			"handle")
;

	if (items < 2)
	    compression_level = 6;
	else {
	    compression_level = (int)SvIV(ST(1))
;
	}

	NYTP_start_deflate(handle, compression_level);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_start_deflate_write_tag_comment); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_start_deflate_write_tag_comment)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "handle, compression_level = 6");
    {
	NYTP_file	handle;
	int	compression_level;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::start_deflate_write_tag_comment",
			"handle")
;

	if (items < 2)
	    compression_level = 6;
	else {
	    compression_level = (int)SvIV(ST(1))
;
	}

	NYTP_start_deflate_write_tag_comment(handle, compression_level);
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_comment); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_comment)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "handle, comment");
    {
	NYTP_file	handle;
	char *	comment = (char *)SvPV_nolen(ST(1))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_comment",
			"handle")
;
#line 1404 "FileHandle.xs"
        RETVAL = NYTP_write_comment(handle, "%s", comment);
#line 1681 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_attribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_attribute)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, key, value");
    {
	NYTP_file	handle;
	SV *	key = ST(1)
;
	SV *	value = ST(2)
;
#line 1414 "FileHandle.xs"
        STRLEN key_len;
        const char *const key_p = SvPVbyte(key, key_len);
        STRLEN value_len;
        const char *const value_p = SvPVbyte(value, value_len);
#line 1705 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_attribute",
			"handle")
;
#line 1419 "FileHandle.xs"
        RETVAL = NYTP_write_attribute_string(handle, key_p, key_len, value_p, value_len);
#line 1718 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_option)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, key, value");
    {
	NYTP_file	handle;
	SV *	key = ST(1)
;
	SV *	value = ST(2)
;
#line 1429 "FileHandle.xs"
        STRLEN key_len;
        const char *const key_p = SvPVbyte(key, key_len);
        STRLEN value_len;
        const char *const value_p = SvPVbyte(value, value_len);
#line 1742 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_option",
			"handle")
;
#line 1434 "FileHandle.xs"
        RETVAL = NYTP_write_option_pv(handle, key_p, value_p, value_len);
#line 1755 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_process_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_process_start)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, pid, ppid, time_of_day");
    {
	NYTP_file	handle;
	U32	pid = (unsigned long)SvUV(ST(1))
;
	U32	ppid = (unsigned long)SvUV(ST(2))
;
	NV	time_of_day = (NV)SvNV(ST(3))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_process_start",
			"handle")
;

	RETVAL = NYTP_write_process_start(handle, pid, ppid, time_of_day);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_process_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_process_end)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, pid, time_of_day");
    {
	NYTP_file	handle;
	U32	pid = (unsigned long)SvUV(ST(1))
;
	NV	time_of_day = (NV)SvNV(ST(2))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_process_end",
			"handle")
;

	RETVAL = NYTP_write_process_end(handle, pid, time_of_day);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_new_fid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_new_fid)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "handle, id, eval_fid, eval_line_num, flags, size, mtime, name");
    {
	NYTP_file	handle;
	U32	id = (unsigned long)SvUV(ST(1))
;
	U32	eval_fid = (unsigned long)SvUV(ST(2))
;
	int	eval_line_num = (int)SvIV(ST(3))
;
	U32	flags = (unsigned long)SvUV(ST(4))
;
	U32	size = (unsigned long)SvUV(ST(5))
;
	U32	mtime = (unsigned long)SvUV(ST(6))
;
	SV *	name = ST(7)
;
#line 1462 "FileHandle.xs"
        STRLEN len;
        const char *const p = SvPV(name, len);
#line 1849 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_new_fid",
			"handle")
;
#line 1465 "FileHandle.xs"
        RETVAL = NYTP_write_new_fid(handle, id, eval_fid, eval_line_num,
                                    flags, size, mtime, p,
                                    SvUTF8(name) ? -(I32)len : (I32)len );
#line 1864 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_time_block); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_time_block)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "handle, elapsed, overflow, fid, line, last_block_line, last_sub_line");
    {
	NYTP_file	handle;
	U32	elapsed = (unsigned long)SvUV(ST(1))
;
	U32	overflow = (unsigned long)SvUV(ST(2))
;
	U32	fid = (unsigned long)SvUV(ST(3))
;
	U32	line = (unsigned long)SvUV(ST(4))
;
	U32	last_block_line = (unsigned long)SvUV(ST(5))
;
	U32	last_sub_line = (unsigned long)SvUV(ST(6))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_time_block",
			"handle")
;

	RETVAL = NYTP_write_time_block(handle, elapsed, overflow, fid, line, last_block_line, last_sub_line);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_time_line); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_time_line)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "handle, elapsed, overflow, fid, line");
    {
	NYTP_file	handle;
	U32	elapsed = (unsigned long)SvUV(ST(1))
;
	U32	overflow = (unsigned long)SvUV(ST(2))
;
	U32	fid = (unsigned long)SvUV(ST(3))
;
	U32	line = (unsigned long)SvUV(ST(4))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_time_line",
			"handle")
;

	RETVAL = NYTP_write_time_line(handle, elapsed, overflow, fid, line);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_call_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_call_entry)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, caller_fid, caller_line");
    {
	NYTP_file	handle;
	U32	caller_fid = (unsigned long)SvUV(ST(1))
;
	U32	caller_line = (unsigned long)SvUV(ST(2))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_call_entry",
			"handle")
;

	RETVAL = NYTP_write_call_entry(handle, caller_fid, caller_line);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_call_return); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_call_return)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "handle, prof_depth, called_subname_pv, incl_subr_ticks, excl_subr_ticks");
    {
	NYTP_file	handle;
	U32	prof_depth = (unsigned long)SvUV(ST(1))
;
	const char *	called_subname_pv = (const char *)SvPV_nolen(ST(2))
;
	NV	incl_subr_ticks = (NV)SvNV(ST(3))
;
	NV	excl_subr_ticks = (NV)SvNV(ST(4))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_call_return",
			"handle")
;

	RETVAL = NYTP_write_call_return(handle, prof_depth, called_subname_pv, incl_subr_ticks, excl_subr_ticks);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_sub_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_sub_info)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "handle, fid, name, first_line, last_line");
    {
	NYTP_file	handle;
	U32	fid = (unsigned long)SvUV(ST(1))
;
	SV *	name = ST(2)
;
	U32	first_line = (unsigned long)SvUV(ST(3))
;
	U32	last_line = (unsigned long)SvUV(ST(4))
;
#line 1511 "FileHandle.xs"
        STRLEN len;
        const char *const p = SvPV(name, len);
#line 2026 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_sub_info",
			"handle")
;
#line 1514 "FileHandle.xs"
        RETVAL = NYTP_write_sub_info(handle, fid,
                                     p, SvUTF8(name) ? -(I32)len : (I32)len,
                                     first_line, last_line);
#line 2041 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_sub_callers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_sub_callers)
{
    dVAR; dXSARGS;
    if (items != 10)
       croak_xs_usage(cv,  "handle, fid, line, caller, count, incl_rtime, excl_rtime, reci_rtime, depth, called_sub");
    {
	NYTP_file	handle;
	U32	fid = (unsigned long)SvUV(ST(1))
;
	U32	line = (unsigned long)SvUV(ST(2))
;
	SV *	caller = ST(3)
;
	U32	count = (unsigned long)SvUV(ST(4))
;
	NV	incl_rtime = (NV)SvNV(ST(5))
;
	NV	excl_rtime = (NV)SvNV(ST(6))
;
	NV	reci_rtime = (NV)SvNV(ST(7))
;
	U32	depth = (unsigned long)SvUV(ST(8))
;
	SV *	called_sub = ST(9)
;
#line 1533 "FileHandle.xs"
        STRLEN caller_len;
        const char *const caller_p = SvPV(caller, caller_len);
        STRLEN called_len;
        const char *const called_p = SvPV(called_sub, called_len);
#line 2079 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_sub_callers",
			"handle")
;
#line 1538 "FileHandle.xs"
        RETVAL = NYTP_write_sub_callers(handle, fid, line, caller_p,
                                        SvUTF8(caller) ? -(I32)caller_len : (I32)caller_len,
                                        count, incl_rtime, excl_rtime,
                                        reci_rtime, depth, called_p,
                                        SvUTF8(called_sub) ? -(I32)called_len : (I32)called_len);
#line 2096 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_src_line); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_src_line)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "handle, fid, line, text");
    {
	NYTP_file	handle;
	U32	fid = (unsigned long)SvUV(ST(1))
;
	U32	line = (unsigned long)SvUV(ST(2))
;
	SV *	text = ST(3)
;
#line 1553 "FileHandle.xs"
        STRLEN len;
        const char *const p = SvPV(text, len);
#line 2120 "FileHandle.c"
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_src_line",
			"handle")
;
#line 1556 "FileHandle.xs"
        RETVAL = NYTP_write_src_line(handle, fid, line,
                                     p, SvUTF8(text) ? -(I32)len : (I32)len);
#line 2134 "FileHandle.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_discount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_discount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "handle");
    {
	NYTP_file	handle;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_discount",
			"handle")
;

	RETVAL = NYTP_write_discount(handle);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__NYTProf__FileHandle_write_header)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "handle, major, minor");
    {
	NYTP_file	handle;
	U32	major = (unsigned long)SvUV(ST(1))
;
	U32	minor = (unsigned long)SvUV(ST(2))
;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isa(ST(0), "Devel::NYTProf::FileHandle"))
	    handle = (NYTP_file)SvPVX(SvRV(ST(0)));
	else
	    Perl_croak(aTHX_ "%s: %s is not of type Devel::NYTProf::FileHandle",
			"Devel::NYTProf::FileHandle::write_header",
			"handle")
;

	RETVAL = NYTP_write_header(handle, major, minor);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Devel__NYTProf__FileHandle); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Devel__NYTProf__FileHandle)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Devel::NYTProf::FileHandle::open", XS_Devel__NYTProf__FileHandle_open);
        cv = newXS_deffile("Devel::NYTProf::FileHandle::DESTROY", XS_Devel__NYTProf__FileHandle_DESTROY);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Devel::NYTProf::FileHandle::close", XS_Devel__NYTProf__FileHandle_DESTROY);
        XSANY.any_i32 = 1;
        newXS_deffile("Devel::NYTProf::FileHandle::write", XS_Devel__NYTProf__FileHandle_write);
#if XSubPPtmpAAAA
        newXS_deffile("Devel::NYTProf::FileHandle::start_deflate", XS_Devel__NYTProf__FileHandle_start_deflate);
        newXS_deffile("Devel::NYTProf::FileHandle::start_deflate_write_tag_comment", XS_Devel__NYTProf__FileHandle_start_deflate_write_tag_comment);
#endif
        newXS_deffile("Devel::NYTProf::FileHandle::write_comment", XS_Devel__NYTProf__FileHandle_write_comment);
        newXS_deffile("Devel::NYTProf::FileHandle::write_attribute", XS_Devel__NYTProf__FileHandle_write_attribute);
        newXS_deffile("Devel::NYTProf::FileHandle::write_option", XS_Devel__NYTProf__FileHandle_write_option);
        newXS_deffile("Devel::NYTProf::FileHandle::write_process_start", XS_Devel__NYTProf__FileHandle_write_process_start);
        newXS_deffile("Devel::NYTProf::FileHandle::write_process_end", XS_Devel__NYTProf__FileHandle_write_process_end);
        newXS_deffile("Devel::NYTProf::FileHandle::write_new_fid", XS_Devel__NYTProf__FileHandle_write_new_fid);
        newXS_deffile("Devel::NYTProf::FileHandle::write_time_block", XS_Devel__NYTProf__FileHandle_write_time_block);
        newXS_deffile("Devel::NYTProf::FileHandle::write_time_line", XS_Devel__NYTProf__FileHandle_write_time_line);
        newXS_deffile("Devel::NYTProf::FileHandle::write_call_entry", XS_Devel__NYTProf__FileHandle_write_call_entry);
        newXS_deffile("Devel::NYTProf::FileHandle::write_call_return", XS_Devel__NYTProf__FileHandle_write_call_return);
        newXS_deffile("Devel::NYTProf::FileHandle::write_sub_info", XS_Devel__NYTProf__FileHandle_write_sub_info);
        newXS_deffile("Devel::NYTProf::FileHandle::write_sub_callers", XS_Devel__NYTProf__FileHandle_write_sub_callers);
        newXS_deffile("Devel::NYTProf::FileHandle::write_src_line", XS_Devel__NYTProf__FileHandle_write_src_line);
        newXS_deffile("Devel::NYTProf::FileHandle::write_discount", XS_Devel__NYTProf__FileHandle_write_discount);
        newXS_deffile("Devel::NYTProf::FileHandle::write_header", XS_Devel__NYTProf__FileHandle_write_header);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 2254 "FileHandle.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

